/*
  DAPA.h
  
  Direct AVR Parallel Access
  
  (c) copyright 1997, Uros Platise  
*/

#ifndef __DAPA
#define __DAPA

#include <sys/types.h>
#include <time.h>
#include <unistd.h>
#include <string>
#include "Error.h"

class TDAPA {
public:
  enum TPaType{
#ifndef NO_DAPA
	PAT_DAPA, PAT_STK200, PAT_ABB,
#endif
	PAT_CASC };

private:
  int parport_base;
  long n_per_ms;
  TPaType pa_type;
#ifdef WIN32
  void *serline;
#else
  int serline;
#endif
  
private:
  void DelayFunc();
  void BigDelay();
  long CalcDelay();
  unsigned char SendRecv(unsigned char b);
  
public:
  /* If enable command 0x53 did not echo back, give a positive SCK
     pulse and retry again.
  */
  void Reset();
  void SCKtoRetryEnable();
  int Send(unsigned char*, int, int rec_queueSize=-1);
  
  TDAPA();
  ~TDAPA();
};
extern int parport_base;

#endif
